<?xml version="1.0" encoding="UTF-8"?>
<domain-models xmlns="http://axelor.com/xml/ns/domain-models"
               xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
               xsi:schemaLocation="http://axelor.com/xml/ns/domain-models
  http://axelor.com/xml/ns/domain-models/domain-models_5.4.xsd">

  <module name="event" package="com.axelor.apps.event.db"/>
  <sequence name="event.seq" increment="1" initial="1" prefix="EV" padding="8" />
  <entity name="Event">
    <string name="code" sequence="event.seq" readonly="true" namecolumn="true"/>
    <many-to-one name="userEntity" title="User" ref="com.axelor.auth.db.User" required="true"/>
    <integer name="state"  title="State" selection="event.event.state.select" default="EventRepository.NOT_STARTED_YET_EVENT" readonly="true" />
    <string name="subject" required="true" />
    <time name="duration" title="Duration"  readonly="true">
      <![CDATA[

      if (eventStartTime != null && eventEndTime != null){
            Duration duration = Duration.between(eventStartTime, eventEndTime);
            LocalTime time = LocalTime.of(0,0);
            return time.plus(duration);
      }
      return null;
    ]]>
    </time>
    <string name="content" large="true" required="true" />
    <string name="relatedToReference" title="Related to"  selection="event.event.related.to.ref.select"/>
    <date name="eventDate" title="Event start date" required="true"/>
    <date name="eventLimitDate" title="Event limit date" required="true"/>
    <time name="eventStartTime" title="Event start" required="true"/>
    <time name="eventEndTime" title="Event end time" required="true"/>


    <extra-imports>
      <![CDATA[
      import com.axelor.apps.event.db.repo.EventRepository;
      import java.time.Duration;

    ]]>
    </extra-imports>
    <extra-code>
      <![CDATA[
    public final static Integer NOT_STARTED_YET_EVENT = 0;
    public final static Integer IN_PROGRESS_EVENT = 1;
    public final static Integer FINISHED_EVENT = 2;
    public final static Integer CANCELED_EVENT = 3;
    ]]>
    </extra-code>
  </entity>

</domain-models>
